package ndk05b;

public class Galeri {
	private Insan galeriSahibi;
	private String galeriAdi;
	private Araba[] arabalar;
	private int arabaSayisi, galeriKapasitesi;
	private int butce;

	public Galeri( String galeriAd, Insan sahip, int galeriKapasitesi ) { 
		galeriAdi = galeriAd; galeriSahibi = sahip;
		this.galeriKapasitesi = galeriKapasitesi;
		arabaSayisi = 0;
		arabalar = new Araba[galeriKapasitesi]; 
	}

	public String getGaleriAdi() { return galeriAdi; }
	public void setGaleriAdi(String galeriAdi) { this.galeriAdi = galeriAdi; }
	public String kendiniTanit( ) {
		String tanitim;
		tanitim = galeriAdi + " adl galerinin sahibi: " + galeriSahibi.getIsim();
		tanitim += "\nGaleride " + arabaSayisi + " adet araba var, "
				+ "toplam kapasite ise " + galeriKapasitesi + " aralktr.";
		tanitim += "\nGalerinin mevcut btesi: " + butce;
		return tanitim;
	}
	public boolean arabaEkle( Araba araba, int alisFiyati ) {
		if( arabaAra(araba.getPlaka()) != null )
			return false;
		if( butce < alisFiyati )
			return false;
		if( arabaSayisi < galeriKapasitesi ) {
			butce -= alisFiyati;
			arabalar[ arabaSayisi ] = araba;
			arabaSayisi++;
			return true;
		}
		else
			return false;
	}
	public Araba arabaAra( String plaka ) {
		for( int i=0; i<arabaSayisi; i++ )
			if( arabalar[i].getPlaka().equalsIgnoreCase(plaka) )
				return arabalar[i];
		return null;
	}
	private int arabaBul( String plaka ) {
		for( int i=0; i<arabaSayisi; i++ )
			if( arabalar[i].getPlaka().equalsIgnoreCase(plaka) )
				return i;
		return -1;

	}
	public boolean arabaSat( String plaka, int satisFiyati ) {
		/* Aslnda daha ok arabaSil gibi.
		 * Sat iin mali konular devreye girer. 
		 * dev olarak yapar msnz? */
		int yer = arabaBul(plaka);
		if( yer != -1 ) {
			for( int i=yer; i<arabaSayisi-1; i++ )
				arabalar[i] = arabalar[i+1];
			arabaSayisi--; arabalar[arabaSayisi] = null;
			butce += satisFiyati;
			return true;
		}
		return false;
	}
	public boolean arabaSat( Araba araba ) {
		if( arabaAra(araba.getPlaka()) == null )
			return false;
		int yer = 0;
		for( int i=0; i<arabaSayisi; i++ ) {
			if( arabalar[i]==araba ) {
				yer = i; break;
			}
		}
		for( int i=yer; i<arabaSayisi-1; i++ )
			arabalar[i] = arabalar[i+1];
		arabalar[arabaSayisi-1] = null; arabaSayisi--; 
		return true;
	}
	public int getButce() {
		return butce;
	}
	public void setButce(int butce) {
		this.butce = butce;
	}
	public boolean kapasiteDegistir( int yeniKapasite ) {
		if( yeniKapasite >= arabaSayisi ) {
			Araba[] yeniDizi = new Araba[yeniKapasite];
			for( int i=0; i<arabaSayisi; i++ )
				yeniDizi[i] = arabalar[i];
			arabalar = yeniDizi;
			return true;
		}
		return false;
	}

}
