package ornekler1D.I;

public class Calisan {
	private String ad, soyad, telefon;
	private final int sicilNo;
	private final Tarih iseGiris;
	private Tarih istenAyrilis;
	private double maas;

	public Calisan(String ad, String soyad, String telefon, 
			int sicilNo, Tarih iseGiris, double maas) {
		this.ad = ad; this.soyad = soyad; this.telefon = telefon;
		this.sicilNo = sicilNo; this.iseGiris = iseGiris;
		this.maas = maas;
	}
	
	public void zamYap( double miktar ) {
		if( miktar > 0 )
			maas += miktar;
	}
	
	public boolean istenAyrildi( Tarih ayrilis ) {
		if( ayrilis.onceMi(iseGiris) )
			return false;
		istenAyrilis = ayrilis; return true;
	}
	
	public String toString( ) {
		String bilgi;
		bilgi = ad + " " + soyad;
		bilgi += "\nTelefon: " + telefon;
		bilgi += "\nSicil no: " + sicilNo;
		bilgi += "\ne giri: " + iseGiris;
		if( istenAyrilis != null )
			bilgi += "\nten k: " + istenAyrilis;
		bilgi += "\nMaa: " + maas;
		return bilgi;
	}
	
	//getter metotlar da eklenir.
}
