package ornekler1D.I;

import java.util.*;

public class Tarih {
	private int gun, ay, yil;
	
	public Tarih( int gun, int ay, int yil ) {
		this.gun = gun; this.ay = ay; this.yil = yil;
		if( !gecerliMi() ) {
			Calendar simdi = Calendar.getInstance();
			this.gun = simdi.get(Calendar.DAY_OF_MONTH); //1-31 aras deer dner
			this.ay = simdi.get(Calendar.MONTH)+1;       //nk 0-11 aras deer dner
			this.yil = simdi.get(Calendar.YEAR);
		}
	}
	
	public boolean esitMi( Tarih diger ) {
		if( this.gun == diger.gun && this.ay == diger.ay 
				&& this.yil == diger.yil )
			return true;
		return false;
	}
	
	public boolean onceMi( Tarih diger ) {
		if( this.yil < diger.yil ) {
			return true;
		}
		else if( this.yil == diger.yil && this.ay < diger.ay ) {
			return true;
		}
		else if( this.yil == diger.yil && this.ay == diger.ay 
				&& this.gun < diger.gun ) {
			return true;
		}
		return false;
	}
	
	public boolean gecerliMi() {
		if( gun <= 0 || ay <= 0 || yil <= 0 )
			return false;
		if( ay > 12 )	return false;
		int maxGun = 30;

		//31 eken aylar: 1 3 5 7
		if( ay < 8 && ay % 2 == 1 )
			maxGun = 31;

		//31 eken aylar: 8 10 12
		else if( ay >= 8 && ay % 2 == 0 )
			maxGun = 31;
		
		/*
		 * Artk yllarda ubat ay 29 eker.
		 * Artk yllar 4 rakamnn kat olan yllardr ancak
		 * 100'n kat olan yllardan sadece 400'e kalansz olarak blnebilenler artk yldr.
		 */
		if ( ay == 2 ) {
			maxGun = 28;
			if( yil % 4 == 0 ) {
				maxGun = 29;
			}
			if( yil % 100 == 0 && yil % 400 != 0 )
				maxGun = 28;
		}
		
		if( gun > maxGun ) return false;
		
		return true;
	}
	
	public String toString() {
		return gun + "/" + ay + "/" + yil;
	}

}
